#include "server_data_interact.h"
#include <engine_engine_number_9/baza_throw.h>

namespace iu9cawebchat {
    json::JSON internalapi_getChatMemberList(SqliteConnection& conn, int64_t uid, const json::JSON& Sent) {
        int64_t chatId = Sent["id"].g().asInteger().get_int();
        int64_t my_role_here = get_role_of_user_in_chat(conn, uid, chatId);
        if (my_role_here == user_chat_role_deleted)
            een9_THROW("Unauthorized user tries to access internalapi_getChatInfo");
        json::JSON Recv;
        Recv["status"] = json::JSON(0l);
        Recv["members"] = json::JSON(json::array);
        std::vector<json::JSON>& members = Recv["members"].g().asArray();
        SqliteStatement req(conn,
            "SELECT `user`.`id`, `user`.`nickname`, `user`.`name`, `user_chat_membership`.`role` FROM "
            "`user` RIGHT JOIN `user_chat_membership` ON `user`.`id` = `user_chat_membership`.`userId` "
            "WHERE `user_chat_membership`.`chatId` = ?1",
            {{1, chatId}}, {});
        while (true) {
            fsql_integer_or_null this_user_id;
            fsql_text8_or_null this_user_nickname, this_user_name;
            fsql_integer_or_null this_users_role;
            int status = sqlite_stmt_step(req, {{0, &this_user_id}, {3, &this_users_role}},
                {{1, &this_user_nickname}, {2, &this_user_name}});
            if (status != SQLITE_ROW)
                break;
            members.emplace_back();
            json::JSON& member = members.back();
            member["id"] = json::JSON(this_user_id.value);
            member["content"]["nickname"] = json::JSON(this_user_nickname.value);
            member["content"]["name"] = json::JSON(this_user_name.value);
            member["content"]["role"] = json::JSON(this_users_role.value);
        }
        return Recv;
    }
}
